#ifndef CALCULATOR_H
#define CALCULATOR_H
/*!
@file calculator.h
@brief Объявление классов - Base, Part, Up, Down, Pyr, Out и структуры Common.
*/
/*
Montgolfier - программа расчета воздушного шара.

Copyright (C) 2010 Igor Ulanov

	Это программа является свободным программным обеспечением. Вы можете распространять и/или модифицировать её согласно условиям Стандартной Общественной Лицензии GNU, опубликованной Фондом Свободного Программного Обеспечения, версии 3 или, по Вашему желанию, любой более поздней версии.
Эта программа распространяется в надежде, что она будет полезной, но БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе подразумеваемых гарантий ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ГОДНОСТИ ДЛЯ ОПРЕДЕЛЁННОГО ПРИМЕНЕНИЯ. Смотрите Стандартную Общественную Лицензию GNU для получения дополнительной информации.
Вы должны были получить копию Стандартной Общественной Лицензии GNU вместе с программой. В случае её отсутствия, посмотрите <http://www.gnu.org/licenses/gpl.html>.
*/

const double pi=3.14159265358979324;//3.1415927;

/*! @struct Common
Структура с параметрами шара задаваемыми пользователем.
*/
struct Common
{
public:
	/// радиус шара в м.
	double r;
	/// угол раскрыва пирамиды в радианах.
	int degree;
	/// угол раскрыва пирамиды в градусах.
	double angle;
	/// радиус выхода в м.
	double r_out;
	/// синус угла раскрыва пирамиды.
	double sin_A;
	/// косинус угла раскрыва пирамиды.
	double cos_A;
	/// ширина заготовки в м.
	double w;
	/// количество лепестков выкройки.
	double n;
	/// вес материала в г/м2.
	double m;
	/// температура воздуха.
	double t_air;
	/// температура воздуха в шаре.
	double t_ball;
	/// радиус сферы в точке касания шара с пирамидой.
	double r_down;
    /// радиус выхода в конечной точке сферы.
    double r_max;
};

/**
@class Base
@brief Базовый класс без реализации, используется как родитель.

Имеет три переменных, для хранения длины, площади и объема. И три функции доступа к этим переменным.
*/
class Base
{
protected:
	/// длина выкройки шара в м.
	double L;
	/// площадь шара в м.
	double S;
	/// объем шара в м.
	double V;
public:
	/// функция возвращает длину выкройки.
	double Get_L(void){return L;}
	/// функция возвращает площадь шара.
	double Get_S(void){return S;}
	/// функция возвращает объем шара.
	double Get_V(void){return V;}
	Base(){}
};

/** Класс без реализации, используется как родитель. В этот класс добавлены виртуальные функции расчетов длин, площадей и объемов частей шара. */
class Part:public Base
{
public:
	Part(){}
	/// функция подсчета длины выкройки.
	virtual double Calc_L(void){return 0;}
	/// функция подсчета площади выкройки.
	virtual double Calc_S(void){return 0;}
	/// функция подсчета объема выкройки.
	virtual double Calc_V(void){return 0;}
};

/** Класс обсчитывающий параметры верхней половины шаровой части шара. */
class Up:public Part
{
public:
	Up(){}
	/// функция подсчета длины выкройки верхней половины шаровой части.
	virtual double Calc_L(void);
	/// функция подсчета площади выкройки верхней половины шаровой части.
	virtual double Calc_S(void);
	/// функция подсчета объема выкройки верхней половины шаровой части.
	virtual double Calc_V(void);
};

/** Класс обсчитывающий параметры нижней половины шаровой части шара. */
class Down:public Part
{
public:
	Down(){}
	/// функция подсчета длины выкройки нижней половины шаровой части.
	virtual double Calc_L(void);
	/// функция подсчета площади выкройки нижней половины шаровой части.
	virtual double Calc_S(void);
	/// функция подсчета <b>объема сегмента</b>. Для получения объема слоя необходимо вычесть из Up::V объем ссегмента.
	virtual double Calc_V(void);
};

/** Класс обсчитывающий параметры пирамидальной части шара. */
class Pyr : public Part
{
public:
	Pyr(void){}
	/// функция подсчета длины выкройки пирамидальной части шара.
	virtual double Calc_L(void);
	/// функция подсчета площади выкройки пирамидальной части шара.
	virtual double Calc_S(void);
	/// функция подсчета объема выкройки пирамидальной части шара.
	virtual double Calc_V(void);
};

/** Класс обсчитывающий параметры пирамидальной части шара ниже выходного отверстия. */
class Out : public Part
{
public:
	Out(void){}
	/// функция подсчета длины выкройки пирамидальной части шара ниже выходного отверстия.
	virtual double Calc_L(void);
	/// функция подсчета площади выкройки пирамидальной части шара ниже выходного отверстия.
	virtual double Calc_S(void);
	/// функция подсчета объема выкройки пирамидальной части шара ниже выходного отверстия.
	virtual double Calc_V(void);
};

#endif // CALCULATOR_H
